diff -rupN arpack++1.2.orig/include/arlsmat.h arpack++1.2.patched/include/arlsmat.h
--- arpack++1.2.orig/include/arlsmat.h	2000-02-22 14:19:46.000000000 +0100
+++ arpack++1.2.patched/include/arlsmat.h	2006-01-26 15:37:50.000000000 +0100
@@ -20,7 +20,7 @@
 #ifndef ARLSMAT_H
 #define ARLSMAT_H
 
-#include <stddef.h>
+#include <cstddef>
 #include "arch.h"
 #include "armat.h"
 #include "arhbmat.h"
@@ -117,12 +117,12 @@ bool ARluSymMatrix<ARTYPE>::DataOK()
   // Checking if pcol is in ascending order.
 
   i = 0;
-  while ((i!=n)&&(pcol[i]<=pcol[i+1])) i++;
-  if (i!=n) return false;
+  while ((i!=this->n)&&(pcol[i]<=pcol[i+1])) i++;
+  if (i!=this->n) return false;
 
   // Checking if irow components are in order and within bounds.
 
-  for (i=0; i!=n; i++) {
+  for (i=0; i!=this->n; i++) {
     j = pcol[i];
     k = pcol[i+1]-1;
     if (j<=k) {
@@ -130,7 +130,7 @@ bool ARluSymMatrix<ARTYPE>::DataOK()
         if ((irow[j]<0)||(irow[k]>i)) return false;
       }
       else { // uplo == 'L'.
-        if ((irow[j]<i)||(irow[k]>=n)) return false;
+        if ((irow[j]<i)||(irow[k]>=this->n)) return false;
       }
       while ((j!=k)&&(irow[j]<irow[j+1])) j++;
       if (j!=k) return false;
@@ -148,12 +148,12 @@ inline void ARluSymMatrix<ARTYPE>::Copy(
 
   // Copying very fundamental variables.
 
-  defined   = other.defined;
+  this->defined   = other.defined;
   factored  = other.factored;
 
   // Returning from here if "other" was not initialized.
 
-  if (!defined) return;
+  if (!this->defined) return;
 
   // Copying user-defined parameters.
 
@@ -183,7 +183,7 @@ void ARluSymMatrix<ARTYPE>::ClearMem()
     Destroy_CompCol_Matrix(&U);
     StatFree();
   }
-  if (defined) {
+  if (this->defined) {
     Destroy_SuperMatrix_Store(&A); // delete A.Store;
     delete[] permc;
     delete[] permr;
@@ -223,13 +223,13 @@ ExpandA(NCformat& A, NCformat& Aexp, ART
 
   // Filling colE with zeros.
 
-  for (i=0; i<=n; i++) colE[i] = 0;
+  for (i=0; i<=this->n; i++) colE[i] = 0;
 
   // Counting the elements in each column of A.
 
   if (uplo == 'U') {
 
-    for (i=0; i!=n; i++) {
+    for (i=0; i!=this->n; i++) {
       k = colA[i+1];
       if ((k!=colA[i])&&(indA[k-1]==i)) {
         k--;
@@ -243,7 +243,7 @@ ExpandA(NCformat& A, NCformat& Aexp, ART
   }
   else { // uplo == 'L'
 
-    for (i=0; i!=n; i++) {
+    for (i=0; i!=this->n; i++) {
       k = colA[i];
       if ((k!=colA[i+1])&&(indA[k]==i)) {
         k++;
@@ -258,18 +258,18 @@ ExpandA(NCformat& A, NCformat& Aexp, ART
 
   // Summing up colE elements.
 
-  for (i=0; i<n; i++) colE[i+1]+=colE[i];
+  for (i=0; i<this->n; i++) colE[i+1]+=colE[i];
 
   // Adding colA to colE.
 
-  for (i=n; i>0; i--) colE[i] = colE[i-1]+colA[i];
+  for (i=this->n; i>0; i--) colE[i] = colE[i-1]+colA[i];
   colE[0] = colA[0];    
 
   // Expanding A.
 
   if (uplo == 'U') {
 
-    for (i=0; i<n; i++) {
+    for (i=0; i<this->n; i++) {
       for (j=colA[i]; j<(colA[i+1]-1); j++) {
         indE[colE[i]] = indA[j];
         indE[colE[indA[j]]] = i; 
@@ -296,7 +296,7 @@ ExpandA(NCformat& A, NCformat& Aexp, ART
   }
   else { // uplo  == 'L'
 
-    for (i=0; i<n; i++) {
+    for (i=0; i<this->n; i++) {
       k=colA[i];
       if ((k!=colA[i+1])&&(indA[k]==i)) {
         indE[colE[i]] = i;
@@ -326,12 +326,12 @@ ExpandA(NCformat& A, NCformat& Aexp, ART
 
   // Adjusting index.
 
-  for (i=n; i>0; i--) {
+  for (i=this->n; i>0; i--) {
     colE[i] = colE[i-1];
   } 
   colE[0] = 0;
 
-  Aexp.nnz = colE[n];
+  Aexp.nnz = colE[this->n];
 
 } // ExpandA.
 
@@ -342,7 +342,7 @@ void ARluSymMatrix<ARTYPE>::FactorA()
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARluSymMatrix::FactorA");
   }
 
@@ -375,9 +375,9 @@ void ARluSymMatrix<ARTYPE>::FactorA()
   // Creating a temporary matrix Aexp.
 
   irowi = new int[nnz*2];
-  pcoli = new int[n+1];
+  pcoli = new int[this->n+1];
   aexp  = new ARTYPE[nnz*2];
-  Create_CompCol_Matrix(&Aexp, n,  n, nnz, aexp, irowi, pcoli, NC, GE);
+  Create_CompCol_Matrix(&Aexp, this->n,  this->n, nnz, aexp, irowi, pcoli, NC, GE);
 
   // Expanding A.
 
@@ -387,7 +387,7 @@ void ARluSymMatrix<ARTYPE>::FactorA()
 
   // Reserving memory for etree (used in matrix decomposition).
 
-  etree = new int[n];
+  etree = new int[this->n];
 
   // Defining LUStat.
 
@@ -421,7 +421,7 @@ void ARluSymMatrix<ARTYPE>::FactorA()
     throw ArpackError(ArpackError::PARAMETER_ERROR,
                       "ARluSymMatrix::FactorA");
   }
-  else if (info > n) {    // Memory is not sufficient.
+  else if (info > this->n) {    // Memory is not sufficient.
     throw ArpackError(ArpackError::MEMORY_OVERFLOW,
                       "ARluSymMatrix::FactorA");
   }
@@ -439,7 +439,7 @@ void ARluSymMatrix<ARTYPE>::FactorAsI(AR
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARluSymMatrix::FactorAsI");
   }
 
@@ -471,10 +471,10 @@ void ARluSymMatrix<ARTYPE>::FactorAsI(AR
 
   // Creating a temporary matrix AsI.
 
-  irowi = new int[nnz*2+n];
-  pcoli = new int[n+1];
-  asi   = new ARTYPE[nnz*2+n];
-  Create_CompCol_Matrix(&AsI, n,  n, nnz, asi, irowi, pcoli, NC, GE);
+  irowi = new int[nnz*2+this->n];
+  pcoli = new int[this->n+1];
+  asi   = new ARTYPE[nnz*2+this->n];
+  Create_CompCol_Matrix(&AsI, this->n,  this->n, nnz, asi, irowi, pcoli, NC, GE);
 
   // Subtracting sigma*I from A and storing the result on AsI.
 
@@ -484,7 +484,7 @@ void ARluSymMatrix<ARTYPE>::FactorAsI(AR
 
   // Reserving memory for etree (used in matrix decomposition).
 
-  etree = new int[n];
+  etree = new int[this->n];
 
   // Defining LUStat.
 
@@ -518,7 +518,7 @@ void ARluSymMatrix<ARTYPE>::FactorAsI(AR
     throw ArpackError(ArpackError::PARAMETER_ERROR,
                       "ARluSymMatrix::FactorAsI");
   }
-  else if (info > n) {    // Memory is not sufficient.
+  else if (info > this->n) {    // Memory is not sufficient.
     throw ArpackError(ArpackError::MEMORY_OVERFLOW,
                       "ARluSymMatrix::FactorAsI");
   }
@@ -539,17 +539,17 @@ void ARluSymMatrix<ARTYPE>::MultMv(ARTYP
 
   // Quitting the function if A was not defined.
 
-  if (!IsDefined()) {
+  if (!this->IsDefined()) {
     throw ArpackError(ArpackError::DATA_UNDEFINED, "ARluSymMatrix::MultMv");
   }
 
   // Determining w = M.v.
 
-  for (i=0; i!=m; i++) w[i]=(ARTYPE)0;
+  for (i=0; i!=this->m; i++) w[i]=(ARTYPE)0;
 
   if (uplo == 'U') {
 
-    for (i=0; i!=n; i++) {
+    for (i=0; i!=this->n; i++) {
       t = v[i];
       k = pcol[i+1];
       if ((k!=pcol[i])&&(irow[k-1]==i)) {
@@ -565,7 +565,7 @@ void ARluSymMatrix<ARTYPE>::MultMv(ARTYP
   }
   else {
 
-    for (i=0; i!=n; i++) {
+    for (i=0; i!=this->n; i++) {
       t = v[i];
       k = pcol[i];
       if ((k!=pcol[i+1])&&(irow[k]==i)) {
@@ -599,8 +599,8 @@ void ARluSymMatrix<ARTYPE>::MultInvv(ART
   int         info;
   SuperMatrix B;
 
-  if (&v != &w) copy(n, v, 1, w, 1);
-  Create_Dense_Matrix(&B, n, 1, w, n, DN, GE);
+  if (&v != &w) copy(this->n, v, 1, w, 1);
+  Create_Dense_Matrix(&B, this->n, 1, w, this->n, DN, GE);
   gstrs("N", &L, &U, permr, permc, &B, &info);
   Destroy_SuperMatrix_Store(&B); // delete B.Store;
 
@@ -613,13 +613,13 @@ DefineMatrix(int np, int nnzp, ARTYPE* a
              char uplop, double thresholdp, int orderp, bool check)
 {
 
-  m         = np;
-  n         = np;
+  this->m         = np;
+  this->n         = np;
   nnz       = nnzp;
   a         = ap;
   irow      = irowp;
   pcol      = pcolp;
-  pcol[n]   = nnz;
+  pcol[this->n]   = nnz;
   uplo      = uplop;
   threshold = thresholdp;
   order     = orderp;
@@ -633,14 +633,14 @@ DefineMatrix(int np, int nnzp, ARTYPE* a
 
   // Creating SuperMatrix A.
 
-  Create_CompCol_Matrix(&A, n, n, nnz, a, irow, pcol, NC, GE);
+  Create_CompCol_Matrix(&A, this->n, this->n, nnz, a, irow, pcol, NC, GE);
 
   // Reserving memory for vectors used in matrix decomposition.
 
-  permc = new int[n];
-  permr = new int[n];
+  permc = new int[this->n];
+  permr = new int[this->n];
 
-  defined = true;
+  this->defined = true;
 
 } // DefineMatrix.
 
diff -rupN arpack++1.2.orig/include/arlsnsym.h arpack++1.2.patched/include/arlsnsym.h
--- arpack++1.2.orig/include/arlsnsym.h	2000-02-21 01:22:42.000000000 +0100
+++ arpack++1.2.patched/include/arlsnsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -18,7 +18,8 @@
 #ifndef ARLSNSYM_H
 #define ARLSNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arsnsym.h"
 #include "arlnsmat.h"
@@ -91,7 +92,7 @@ Copy(const ARluNonSymStdEig<ARFLOAT>& ot
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARluNonSymMatrix<ARFLOAT, ARFLOAT> >:: Copy(other);
-  if (mode > 2) objOP->FactorAsI(sigmaR);
+  if (this->mode > 2) this->objOP->FactorAsI(this->sigmaR);
 
 } // Copy.
 
@@ -100,13 +101,13 @@ template<class ARFLOAT>
 inline void ARluNonSymStdEig<ARFLOAT>::ChangeShift(ARFLOAT sigmaRp)
 {
 
-  sigmaR    = sigmaRp;
-  sigmaI    = 0.0;
-  mode      = 3;
-  iparam[7] = mode;
+  this->sigmaR    = sigmaRp;
+  this->sigmaI    = 0.0;
+  this->mode      = 3;
+  this->iparam[7] = this->mode;
 
-  objOP->FactorAsI(sigmaR);
-  Restart();
+  this->objOP->FactorAsI(this->sigmaR);
+  this->Restart();
 
 } // ChangeShift.
 
@@ -116,7 +117,7 @@ inline void ARluNonSymStdEig<ARFLOAT>::S
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARluNonSymMatrix<ARFLOAT, ARFLOAT> >::
-    SetRegularMode(objOP, &ARluNonSymMatrix<ARFLOAT, ARFLOAT>::MultMv);
+    SetRegularMode(this->objOP, &ARluNonSymMatrix<ARFLOAT, ARFLOAT>::MultMv);
 
 } // SetRegularMode.
 
@@ -126,7 +127,7 @@ inline void ARluNonSymStdEig<ARFLOAT>::S
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARluNonSymMatrix<ARFLOAT, ARFLOAT> >::
-    SetShiftInvertMode(sigmap, objOP, 
+    SetShiftInvertMode(sigmap, this->objOP, 
                        &ARluNonSymMatrix<ARFLOAT, ARFLOAT>::MultInvv);
 
 } // SetShiftInvertMode.
@@ -140,7 +141,7 @@ ARluNonSymStdEig(int nevp, ARluNonSymMat
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &A, 
                    &ARluNonSymMatrix<ARFLOAT, ARFLOAT>::MultMv,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
@@ -170,7 +171,7 @@ operator=(const ARluNonSymStdEig<ARFLOAT
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arlspen.h arpack++1.2.patched/include/arlspen.h
--- arpack++1.2.orig/include/arlspen.h	2000-02-22 14:20:33.000000000 +0100
+++ arpack++1.2.patched/include/arlspen.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARLSPEN_H
 #define ARLSPEN_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arerror.h"
 #include "blas1c.h"
diff -rupN arpack++1.2.orig/include/arlssym.h arpack++1.2.patched/include/arlssym.h
--- arpack++1.2.orig/include/arlssym.h	2000-03-03 22:13:06.000000000 +0100
+++ arpack++1.2.patched/include/arlssym.h	2006-01-26 15:37:50.000000000 +0100
@@ -19,7 +19,8 @@
 #ifndef ARLSSYM_H
 #define ARLSSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arssym.h"
 #include "arlsmat.h"
@@ -92,7 +93,7 @@ inline void ARluSymStdEig<ARFLOAT>::Copy
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARluSymMatrix<ARFLOAT> >:: Copy(other);
-  if (mode > 2) objOP->FactorAsI(sigmaR);
+  if (this->mode > 2) this->objOP->FactorAsI(this->sigmaR);
 
 } // Copy.
 
@@ -101,13 +102,13 @@ template<class ARFLOAT>
 inline void ARluSymStdEig<ARFLOAT>::ChangeShift(ARFLOAT sigmaRp)
 {
 
-  sigmaR    = sigmaRp;
-  sigmaI    = 0.0;
-  mode      = 3;
-  iparam[7] = mode;
+  this->sigmaR    = sigmaRp;
+  this->sigmaI    = 0.0;
+  this->mode      = 3;
+  this->iparam[7] = this->mode;
 
-  objOP->FactorAsI(sigmaR);
-  Restart();
+  this->objOP->FactorAsI(this->sigmaR);
+  this->Restart();
 
 } // ChangeShift.
 
@@ -117,7 +118,7 @@ inline void ARluSymStdEig<ARFLOAT>::SetR
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARluSymMatrix<ARFLOAT> >::
-    SetRegularMode(objOP, &ARluSymMatrix<ARFLOAT>::MultMv);
+    SetRegularMode(this->objOP, &ARluSymMatrix<ARFLOAT>::MultMv);
 
 } // SetRegularMode.
 
@@ -127,7 +128,7 @@ inline void ARluSymStdEig<ARFLOAT>::SetS
 {
 
   ARStdEig<ARFLOAT, ARFLOAT, ARluSymMatrix<ARFLOAT> >::
-    SetShiftInvertMode(sigmap, objOP, &ARluSymMatrix<ARFLOAT>::MultInvv);
+    SetShiftInvertMode(sigmap, this->objOP, &ARluSymMatrix<ARFLOAT>::MultInvv);
 
 } // SetShiftInvertMode.
 
@@ -139,7 +140,7 @@ ARluSymStdEig(int nevp, ARluSymMatrix<AR
               int maxitp, ARFLOAT* residp, bool ishiftp)
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(A.ncols(), nevp, &A, &ARluSymMatrix<ARFLOAT>::MultMv,
                    whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
@@ -167,7 +168,7 @@ operator=(const ARluSymStdEig<ARFLOAT>& 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrgcomp.h arpack++1.2.patched/include/arrgcomp.h
--- arpack++1.2.orig/include/arrgcomp.h	2000-02-21 17:29:48.000000000 +0100
+++ arpack++1.2.patched/include/arrgcomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARRGCOMP_H
 #define ARRGCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arrscomp.h"
 #include "arrgeig.h"
@@ -71,7 +72,7 @@ ARrcCompGenEig(int np, int nevp, char* w
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
 } // Long constructor (regular mode).
@@ -97,7 +98,7 @@ operator=(const ARrcCompGenEig<ARFLOAT>&
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrgeig.h arpack++1.2.patched/include/arrgeig.h
--- arpack++1.2.orig/include/arrgeig.h	2000-02-21 17:28:50.000000000 +0100
+++ arpack++1.2.patched/include/arrgeig.h	2006-01-26 15:37:50.000000000 +0100
@@ -66,11 +66,11 @@ template<class ARFLOAT, class ARTYPE>
 inline void ARrcGenEig<ARFLOAT, ARTYPE>::NoShift()
 {
 
-  sigmaR    = (ARTYPE)0;
-  sigmaI    = 0.0;
-  mode      = 2;
-  iparam[7] = mode;
-  Restart();
+  this->sigmaR    = (ARTYPE)0;
+  this->sigmaI    = 0.0;
+  this->mode      = 2;
+  this->iparam[7] = this->mode;
+  this->Restart();
 
 } // NoShift.
 
@@ -79,8 +79,8 @@ template<class ARFLOAT, class ARTYPE>
 inline ARrcGenEig<ARFLOAT, ARTYPE>::ARrcGenEig()
 {
 
-  bmat = 'G';   // This is a generalized problem.
-  NoShift();
+  this->bmat = 'G';   // This is a generalized problem.
+  this->NoShift();
 
 } // Short constructor.
 
@@ -91,7 +91,7 @@ operator=(const ARrcGenEig<ARFLOAT, ARTY
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrgnsym.h arpack++1.2.patched/include/arrgnsym.h
--- arpack++1.2.orig/include/arrgnsym.h	2000-02-21 17:27:48.000000000 +0100
+++ arpack++1.2.patched/include/arrgnsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARRGNSYM_H
 #define ARRGNSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arrsnsym.h"
 #include "arrgeig.h"
@@ -50,7 +51,7 @@ class ARrcNonSymGenEig:
 
  // c.1) Functions that provides access to internal variables' values.
 
-  ARFLOAT GetShiftImag() { return sigmaI; }
+  ARFLOAT GetShiftImag() { return this->sigmaI; }
   // Returns the imaginary part of the shift (when in shift and invert mode).
 
 
@@ -141,13 +142,13 @@ inline void ARrcNonSymGenEig<ARFLOAT>::C
 
   part = CheckPart(partp);
   if (part == 'R') {
-    mode    = 3;    // Real part.
+    this->mode    = 3;    // Real part.
   }
   else {
-    mode    = 4;    // Imaginary part.
+    this->mode    = 4;    // Imaginary part.
   }
-  iparam[7] = mode;
-  Restart();
+  this->iparam[7] = this->mode;
+  this->Restart();
 
 } // ChangePart.
 
@@ -157,8 +158,8 @@ inline void ARrcNonSymGenEig<ARFLOAT>::
 ChangeShift(ARFLOAT sigmaRp, ARFLOAT sigmaIp)
 {
 
-  sigmaR    = sigmaRp;
-  sigmaI    = sigmaIp;
+  this->sigmaR    = sigmaRp;
+  this->sigmaI    = sigmaIp;
   ChangePart(part);
 
 } // ChangeShift.
@@ -193,7 +194,7 @@ ARrcNonSymGenEig(int np, int nevp, char*
 {
 
   part = 'R';                // Considering mode = 3 in ChangeShift.
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
 } // Long constructor (regular mode).
@@ -231,7 +232,7 @@ operator=(const ARrcNonSymGenEig<ARFLOAT
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrgsym.h arpack++1.2.patched/include/arrgsym.h
--- arpack++1.2.orig/include/arrgsym.h	2000-02-21 15:50:06.000000000 +0100
+++ arpack++1.2.patched/include/arrgsym.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARRGSYM_H
 #define ARRGSYM_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arrssym.h"
 #include "arrgeig.h"
@@ -129,17 +130,17 @@ inline void ARrcSymGenEig<ARFLOAT>::Chan
   InvertMode = CheckInvertMode(InvertModep);
   switch (InvertMode) {
   case 'S':
-    mode    = 3;    // Shift and invert mode.
+    this->mode    = 3;    // Shift and invert mode.
     break;
   case 'B':
-    mode    = 4;    // Buckling mode.
+    this->mode    = 4;    // Buckling mode.
     break;
   case 'C':
-    mode    = 5;    // Cayley mode.
+    this->mode    = 5;    // Cayley mode.
     break;
   }
-  iparam[7] = mode;
-  Restart();
+  this->iparam[7] = this->mode;
+  this->Restart();
 
 } // ChangeInvertMode.
 
@@ -148,8 +149,8 @@ template<class ARFLOAT>
 inline void ARrcSymGenEig<ARFLOAT>::ChangeShift(ARFLOAT sigmap)
 {
 
-  sigmaR    = sigmap;
-  sigmaI    = 0.0;
+  this->sigmaR    = sigmap;
+  this->sigmaI    = 0.0;
   ChangeInvertMode(InvertMode);
 
 } // ChangeShift.
@@ -196,7 +197,7 @@ ARrcSymGenEig(int np, int nevp, char* wh
 {
 
   InvertMode = 'S';   // Considering mode = 3 in ChangeShift.
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
 } // Long constructor (regular mode).
@@ -223,7 +224,7 @@ operator=(const ARrcSymGenEig<ARFLOAT>& 
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrscomp.h arpack++1.2.patched/include/arrscomp.h
--- arpack++1.2.orig/include/arrscomp.h	2000-03-03 21:29:58.000000000 +0100
+++ arpack++1.2.patched/include/arrscomp.h	2006-01-26 15:37:50.000000000 +0100
@@ -17,7 +17,8 @@
 #ifndef ARRSCOMP_H
 #define ARRSCOMP_H
 
-#include <stddef.h>
+#include <cstddef>
+
 #include "arch.h"
 #include "arerror.h"
 #include "debug.h"
@@ -138,12 +139,12 @@ template<class ARFLOAT>
 inline void ARrcCompStdEig<ARFLOAT>::WorkspaceAllocate()
 {
 
-  lworkl  = ncv*(3*ncv+6);
-  lworkv  = 2*ncv;
-  lrwork  = ncv;
-  workl   = new arcomplex<ARFLOAT>[lworkl+1];
-  workv   = new arcomplex<ARFLOAT>[lworkv+1];
-  rwork   = new ARFLOAT[lrwork+1];
+  this->lworkl  = this->ncv*(3*this->ncv+6);
+  this->lworkv  = 2*this->ncv;
+  this->lrwork  = this->ncv;
+  this->workl   = new arcomplex<ARFLOAT>[this->lworkl+1];
+  this->workv   = new arcomplex<ARFLOAT>[this->lworkv+1];
+  this->rwork   = new ARFLOAT[this->lrwork+1];
 
 } // WorkspaceAllocate.
 
@@ -152,8 +153,8 @@ template<class ARFLOAT>
 inline void ARrcCompStdEig<ARFLOAT>::Aupp()
 {
 
-  caupp(ido, bmat, n, which, nev, tol, resid, ncv, V, n,
-        iparam, ipntr, workd, workl, lworkl, rwork, info);
+  caupp(this->ido, this->bmat, this->n, this->which, this->nev, this->tol, this->resid, this->ncv, this->V, this->n,
+        this->iparam, this->ipntr, this->workd, this->workl, this->lworkl, this->rwork, this->info);
 
 } // Aupp.
 
@@ -162,9 +163,9 @@ template<class ARFLOAT>
 inline void ARrcCompStdEig<ARFLOAT>::Eupp()
 {
 
-  ceupp(rvec, HowMny, EigValR, EigVec, n, sigmaR, workv,
-        bmat, n, which, nev, tol, resid, ncv, V, n, iparam,
-        ipntr, workd, workl, lworkl, rwork, info);
+  ceupp(this->rvec, this->HowMny, this->EigValR, this->EigVec, this->n, this->sigmaR, this->workv,
+        this->bmat, this->n, this->which, this->nev, this->tol, this->resid, this->ncv, this->V, this->n, this->iparam,
+        this->ipntr, this->workd, this->workl, this->lworkl, this->rwork, this->info);
 
 } // Eupp.
 
@@ -174,36 +175,36 @@ int ARrcCompStdEig<ARFLOAT>::
 Eigenvalues(arcomplex<ARFLOAT>* &EigValp, bool ivec, bool ischur)
 {
 
-  if (ValuesOK) {                      // Eigenvalues are available .
+  if (this->ValuesOK) {                      // Eigenvalues are available .
     if (EigValp == NULL) {             // Moving eigenvalues.
-      EigValp  = EigValR;
-      EigValR  = NULL;
-      newVal   = false;
-      ValuesOK = false;
+      EigValp  = this->EigValR;
+      this->EigValR  = NULL;
+      this->newVal   = false;
+      this->ValuesOK = false;
     }
     else {                             // Copying eigenvalues.
-      copy(nconv,EigValR,1,EigValp,1);
+      copy(this->nconv,this->EigValR,1,EigValp,1);
     }
   }
   else {
-    if (newVal) {
-      delete[] EigValR;
-      newVal = false;
+    if (this->newVal) {
+      delete[] this->EigValR;
+      this->newVal = false;
     }
     if (EigValp == NULL) {
-      try { EigValp = new arcomplex<ARFLOAT>[ValSize()]; }
+      try { EigValp = new arcomplex<ARFLOAT>[this->ValSize()]; }
       catch (ArpackError) { return 0; }
     }
-    EigValR = EigValp;
+    this->EigValR = EigValp;
     if (ivec) {                        // Finding eigenvalues and eigenvectors.
-      nconv = FindEigenvectors(ischur);
+      this->nconv = this->FindEigenvectors(ischur);
     }
     else {                             // Finding eigenvalues only.
-      nconv = FindEigenvalues();
+      this->nconv = this->FindEigenvalues();
     }
-    EigValR = NULL;
+    this->EigValR = NULL;
   }
-  return nconv;
+  return this->nconv;
 
 } // Eigenvalues(EigValp, ivec, ischur).
 
@@ -214,31 +215,31 @@ EigenValVectors(arcomplex<ARFLOAT>* &Eig
                 bool ischur)
 {
 
-  if (ValuesOK) {                  // Eigenvalues are already available.
-    nconv = Eigenvalues(EigValp, false);
-    nconv = Eigenvectors(EigVecp, ischur);
+  if (this->ValuesOK) {                  // Eigenvalues are already available.
+    this->nconv = Eigenvalues(EigValp, false);
+    this->nconv = Eigenvectors(EigVecp, ischur);
   }
   else {                           // Eigenvalues and vectors are not available.
-    if (newVec) {
-      delete[] EigVec;
-      newVec = false;
+    if (this->newVec) {
+      delete[] this->EigVec;
+      this->newVec = false;
     }
-    if (newVal) {
-      delete[] EigValR;
-      newVal = false;
+    if (this->newVal) {
+      delete[] this->EigValR;
+      this->newVal = false;
     }  
     try {
-      if (EigVecp == NULL) EigVecp = new arcomplex<ARFLOAT>[ValSize()*n];
-      if (EigValp == NULL) EigValp = new arcomplex<ARFLOAT>[ValSize()];
+      if (EigVecp == NULL) EigVecp = new arcomplex<ARFLOAT>[this->ValSize()*this->n];
+      if (EigValp == NULL) EigValp = new arcomplex<ARFLOAT>[this->ValSize()];
     }
     catch (ArpackError) { return 0; }
-    EigVec  = EigVecp;
-    EigValR = EigValp;
-    nconv   = FindEigenvectors(ischur);
-    EigVec  = NULL;
-    EigValR = NULL;
+    this->EigVec  = EigVecp;
+    this->EigValR = EigValp;
+    this->nconv   = this->FindEigenvectors(ischur);
+    this->EigVec  = NULL;
+    this->EigValR = NULL;
   }
-  return nconv;
+  return this->nconv;
 
 } // EigenValVectors(EigVecp, EigValp, ischur).
 
@@ -251,13 +252,13 @@ inline arcomplex<ARFLOAT> ARrcCompStdEig
 
   // Returning i-eth eigenvalue.
 
-  if (!ValuesOK) {
+  if (!this->ValuesOK) {
     throw ArpackError(ArpackError::VALUES_NOT_OK, "Eigenvalue(i)");
   }
-  else if ((i>=nconv)||(i<0)) {
+  else if ((i>=this->nconv)||(i<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "Eigenvalue(i)");
   }
-  return EigValR[i];
+  return this->EigValR[i];
 
 } // Eigenvalue(i).
 
@@ -269,13 +270,13 @@ Eigenvector(int i, int j)
 
   // Returning element j of i-eth eigenvector.
 
-  if (!VectorsOK) {
+  if (!this->VectorsOK) {
     throw ArpackError(ArpackError::VECTORS_NOT_OK, "Eigenvector(i,j)");
   }
-  else if ((i>=nconv)||(i<0)||(j>=n)||(j<0)) {
+  else if ((i>=this->nconv)||(i<0)||(j>=this->n)||(j<0)) {
     throw ArpackError(ArpackError::RANGE_ERROR, "Eigenvector(i,j)");
   }
-  return EigVec[i*n+j];
+  return this->EigVec[i*this->n+j];
 
 } // Eigenvector(i,j).
 
@@ -336,7 +337,7 @@ ARrcCompStdEig(int np, int nevp, char* w
 
 {
 
-  NoShift();
+  this->NoShift();
   DefineParameters(np, nevp, whichp, ncvp, tolp, maxitp, residp, ishiftp);
 
 } // Long constructor (regular mode).
@@ -362,7 +363,7 @@ operator=(const ARrcCompStdEig<ARFLOAT>&
 {
 
   if (this != &other) { // Stroustrup suggestion.
-    ClearMem();
+    this->ClearMem();
     Copy(other);
   }
   return *this;
diff -rupN arpack++1.2.orig/include/arrseig.h arpack++1.2.patched/include/arrseig.h
--- arpack++1.2.orig/include/arrseig.h	2000-03-03 22:09:44.000000000 +0100
+++ arpack++1.2.patched/include/arrseig.h	2006-01-26 15:37:50.000000000 +0100
@@ -19,8 +19,9 @@
 #ifndef ARRSEIG_H
 #define ARRSEIG_H
 
-#include <new.h>
-#include <stddef.h>
+#include <new>
+#include <cstddef>
+
 #include "arch.h"
 #include "arerror.h"
 #include "debug.h"
@@ -837,7 +838,7 @@ DefineParameters(int np, int nevp, char*
 
   // Providing a "new" handler.
 
-  set_new_handler(MemoryOverflow);
+  std::set_new_handler ( MemoryOverflow );
 
   // Setting user defined parameters.
 
